<?

// --------------------------------------------------------------------------
// Database ڷ   
// --------------------------------------------------------------------------


// ###########################################################################

class MySQL {

	function connect ($db_host, $db_user, $db_pass) {
		return mysql_connect($db_host, $db_user, $db_pass);
	}
	function select ($db_name) {
		return mysql_select_db($db_name);
	}
	function query ($query) {
		GLOBAL $debug;
		if ($debug) { print "$query<BR>\n"; }
		return mysql_query($query);
	}
	function numrows ($result) {
		return mysql_num_rows($result);
	}
	function result ($result, $count, $col) {
		return mysql_result($result, $count, $col);
	}
	function fetcharray ($result, $row) {
		unset($row);	// MySQL  
		return mysql_fetch_array($result);
	}
	function insertid () {
		return mysql_insert_id();
	}
	function error ($mode) {
		GLOBAL $lib;
		GLOBAL $dbi;
		$err = mysql_error();
		if ($mode && $err != "") { $lib->errorprint("SQL ERROR", $err); }
		return $err;
	}
	function listtables () {
		GLOBAL $dbi;
		return mysql_list_tables($dbi[name]);
	}

} //-- Class End

// ###########################################################################

class PostgreSQL {

	function connect ($db_options) {
		return pg_connect($db_options);
	}
	function query ($query) {
		GLOBAL $dbi;
		GLOBAL $debug;
		if ($debug) { print "$query<BR>\n"; }
		return pg_exec($dbi[connect], $query);
	}
	function numrows ($result) {
		return pg_numrows($result);
	}
	function result ($result, $count, $col) {
		return pg_result($result, $count, $col);
	}
	function fetcharray ($result, $row) {
		return pg_fetch_array($result, $row);
	}
	function error ($mode) {
		GLOBAL $lib;
		GLOBAL $dbi;
		$err = pg_errormessage($dbi[connect]);
		if ($mode && $err != "") { $lib->errorprint("SQL ERROR", $err); }
		return $err;
	}
	function listtables () {
		return $this->query("SELECT relname FROM pg_class WHERE relkind = 'r' AND relname NOT LIKE 'pg_%'");
	}

} //-- Class End

// ###########################################################################

class DbControl {

	function dbinit () {
		GLOBAL $sql, $lib;
		GLOBAL $dbi;
		if ($dbi[engn] == "MySQL") {
			$dbi[host] = $dbi[port] ? "$dbi[host]:$dbi[port]" : $dbi[host];
			if (!$sql->connect($dbi[host], $dbi[user], $dbi[pass])) {
				$lib->errorprint("MySQL Connection Failed.", "");
			}
			$sql->select($dbi[name]);
		}
		elseif ($dbi[engn] == "PostgreSQL") {
			// $dbi[options]= "host=Host port=Port user=User password=Password dbname=Dbname";
			$dbi[options] = "";
			$dbi[options] .= $dbi[host] != "" ? " host=$dbi[host]" : "";
			$dbi[options] .= $dbi[port] != "" ? " port=$dbi[port]" : " port=5432";
			$dbi[options] .= $dbi[user] != "" ? " user=$dbi[user]" : "";
			$dbi[options] .= $dbi[pass] != "" ? " password=$dbi[pass]" : "";
			$dbi[options] .= $dbi[name] != "" ? " dbname=$dbi[name]" : "";
			$dbi[options] = trim($dbi[options]);
			$dbi[connect] = $sql->connect($dbi[options]);
			if (!$dbi[connect]) {
				$lib->errorprint("PostgreSQL Connection Failed.", "");
			}
		}
		$result = $sql->query("SELECT VERSION()");
		$row = $sql->numrows($result);
		if ($row) { $dbi[version] = $sql->result($result, 0, 0); }
		else { $dbi[version] = "" ; }
	}
	function artcount ($table, $where) {
		GLOBAL $sql;
		$where = $where ? "WHERE $where" : "";
		$result = $sql->query(
				"SELECT COUNT(number) FROM $table $where");
		$row = $sql->numrows($result);
		if ($row) { $art_count = $sql->result($result, 0, 0); }
		else { $art_count = 0 ; }
		settype($art_count, "integer");
		return $art_count;
	}
	function getart ($table, $field, $where, $err) {
		GLOBAL $sql, $js, $misc;
		GLOBAL $na;
		GLOBAL $number, $meta_base;
		$where = $where ? "WHERE $where" : "";
		$result = $sql->query("SELECT $field FROM $table $where");
		//  Խù   翩 
		$row = $sql->numrows($result);
		if(!$row && $err) {
			$js->error($misc->msg("ART_NOT_EXIST") . "($na[number]:$number)", $meta_base);
		}
		elseif ($row) { $art = $sql->fetcharray($result, 0); }
		else { $art = ""; }
		return $art;
	}
	function getartlist ($table, $field, $where, $offset, $pageline) {
		GLOBAL $sql;
		GLOBAL $dbi;
		GLOBAL $sort;
		$where = $where ? "WHERE $where" : "";
		if ($dbi[engn] == "MySQL") { $limit = "LIMIT $offset, $pageline"; }
		elseif ($dbi[engn] == "PostgreSQL") { $limit = "LIMIT $pageline, $offset"; }
		$result = $sql->query("SELECT $field FROM $table $where $sort[asc] $limit");
		$row = $sql->numrows($result);
		for ($i = 0; $i < $row; $i++) {
			$rec = $sql->fetcharray($result, $i);
			$art_list[] = $rec;
		}
		return $art_list;
	}

} //-- Class End

// ###########################################################################

?>
