<?

// --------------------------------------------------------------------------
//  ̺귯
// --------------------------------------------------------------------------


// ###########################################################################

class Lib {

	function mailer ($from, $fname, $to, $cc, $bcc, $subject, $content,
			$file, $type, $charset, $textencode) {
		// to, cc, bcc :   , ȣ и
		// file : array(array(name,data), ...)
		// type : html=1, text=0
		$charset = $charset =! "" ? "; charset=$charset" : "";
		$add_header  = "From: $from ($fname)\n";
		$add_header .= "Reply-To: $from\n";
		if ($cc != "") { $add_header .= "Cc: $cc\n"; }
		if ($bcc != "") { $add_header .= "Bcc: $bcc\n"; }
		if ($file == "") {
			if ($type) {
				$add_header .= "MIME-Version: 1.0\n";
				$add_header .= "Content-Type: text/html$charset\n"; }
			else { $add_header .= "Content-Type: text/plain$charset\n"; }
		$add_header .= "X-Mailer: Way-SERIES Mailer 1.1 PHP - http://way.co.kr";
		}
		else {
			$boundary = "___==MultiPart_" . strtoupper(md5(uniqid(rand()))) . "==___";
			$add_header .= "MIME-Version: 1.0\n";
			$add_header .= "Content-type: multipart/mixed; BOUNDARY=\"$boundary\"\n";
			$add_header .= "X-Mailer: Way-SERIES Mailer 1.1 PHP - http://way.co.kr\n\n";
			$add_header .= "This is a multi-part message in MIME format.\n\n";
			$add_header .= "--$boundary\n";
			if ($type) {
				$add_header .= "Content-Type: text/html$charset\n"; }
			else {
				$add_header .= "Content-Type: text/plain$charset\n"; }
			$add_header .= "Content-Transfer-Encoding: $textencode\n\n";
			$add_header .= $content . "\n\n";
			for ($i=0; $i < sizeof($file); $i++) {
				$add_header .= "--" . $boundary . "\n";
				$add_header .= "Content-Type: application/octet-stream;";
				$add_header .= " name=\"" . $file[$i][name] . "\"\n";
				$add_header .= "Content-Transfer-Encoding: base64\n";
				$add_header .= "Content-Disposition: attachment;";
				$add_header .= " filename=\"" . $file[$i][name] . "\"\n\n";
				// BASE64 Encode
				$filedata = base64_encode($file[$i][data]);
				$filedata = chunk_split($filedata);
				$add_header .= $filedata . "\n";
			}
			$add_header .= "--" . $boundary . "--\n";
			$content = "";
		}
		$content = ereg_replace("\r?\n\.\r?\n", "\n .\n", $content);
		$add_header = ereg_replace("\r?\n\.\r?\n", "\n .\n", $add_header);
		return mail($to, $subject, $content, $add_header);
	}
	function gettoday ($tz) {
		$now    = time() + $tz;
		$today  = $now - ($now % 86400);
		$today -= $tz;
		return $today;
	}
	function getfixday ($today, $day) {
		$fixday = $today - ($day*24*60*60);
		return $fixday;
	}
	function stringcut ($str, $len, $trail, $using) {
		// ڿ, ѱ, ,  뿩
		if(strlen($str) <= $len) { return $str; }
		$flag = FALSE;
		$len--;
		if ($using) { $len -= strlen($trail); }
		for ($i=0; $i < $len; $i++) {
			$k = ord($str[$i]);
			if ($k > 160 && $k < 255) { $flag = $flag ? FALSE : TRUE; }
			else { $flag = FALSE; }
		}
		if ($len > 0) { $str = $flag ? substr($str, 0, $len+1) : substr($str, 0, $len); }
		else { $str = ""; }
		if ($using) { $str = $str . $trail; }
		return $str;
	}
	function mailcheck ($mail, $empty=0) {
		$mail = trim($mail);
		if ($mail == "") { return $empty; }
		if ( eregi("^.+@(\[?)[a-zA-Z0-9\._-]+\.([a-zA-Z]{2,}|[0-9]{1,3})(\]?)$", $mail) &&
			!eregi("(@.*@)|(\.\.)|(@\.)|(\.@)|(^\.)", $mail) ) { return 1; }
		else { return 0; }
	}
	function urlmake ($url, $empty) {
		// URL Protocol 
		$url = trim($url);
		if ($url == "") { return $empty; }
		if (eregi("^(http|https|ftp|mailto|telnet|news)://", $url) ) { return $url; }
		else { return "http://$url"; }
	}
	function getextension ($filename) {
		if (!ereg("\.", $filename)) { return ""; }
		$name_slice = explode(".", $filename);
		return strtolower($name_slice[sizeof($name_slice)-1]);
	}
	function byteunit ($byte, $soft, $kcut) {
		// soft = 1 : 1000  
		// kcut = Kbyte  Ҽ  
		if ($soft && !($byte%1000)) { $unit = 1000; }
		else { $unit = 1024; }
		if ($byte >= ($unit*$unit*$unit)) {
			$result = sprintf("%.2f", $byte / ($unit*$unit*$unit)) . "G";
		}
		elseif ($byte >= ($unit*$unit)) {
			$result = sprintf("%.2f", $byte / ($unit*$unit)) . "M";
		}
		elseif ($byte >= ($unit)) {
			$result = sprintf("%.2f", $byte / ($unit)) . "K";
			if ($kcut) { $result = ereg_replace("\.[0-9]+", "", $result); }
		}
		else { $result = $byte; }
		$result = eregi_replace("\.00([A-Z]+)", "\\1", $result);
		return $result;
	}
	function scriptdel(&$str) {
		// PHP, JavaScript  Ǵ
		// <?, <?php, <% Ǵ <SCRIPT></SCRIPT> ± ؼ 
		$str = ereg_replace("<\?", "&lt;?", $str);
		$str = ereg_replace("\?>", "?&gt;", $str);
		$str = ereg_replace("<\%", "&lt;%", $str);
		$str = ereg_replace("\%>", "%&gt;", $str);
		$str = eregi_replace("<(SCRIPT)([^>]*)>", "&lt;\\1\\2&gt;", $str);
		$str = eregi_replace("</(SCRIPT)>", "&lt;/\\1&gt;", $str);
	}
	function newlineconv(&$str) {
		$str = ereg_replace("\r\n", "\n", $str);	// Windows(CR,LF) -> LF
		$str = ereg_replace("\r", "\n", $str);		// Mac(CR) -> LF
	}
	function htmlchars($str) {
		$str = htmlspecialchars($str);
		// Ȯϼ ó
		return eregi_replace("&amp;#", "&#", $str);
	}
	function tagdel ($str) {
		$str = ereg_replace("<[^>]*(>|$)", "", $str);
		return $str;
	}
	function errorprint($title, $msg) {
		print "
<HTML>
<HEAD>
<TITLE>$title</TITLE>
</HEAD>
<BODY>
<BR><BR>
<H2>$title</H2>
$msg
</BODY>
</HTML>
";
		exit;
	}

} //-- Class End

// ###########################################################################

class JavaScript {

	function error ($msg, $meta) {
		$this->msgback($msg, 1, $meta);
	}
	function msgback ($msg, $page, $meta) {
		print "
<HTML>
<HEAD>
<TITLE></TITLE>
$meta
<META HTTP-EQUIV=\"Pragma\" CONTENT=\"no-cache\">
<META HTTP-EQUIV=\"Expires\" CONTENT=\"0\">
</HEAD>
<BODY>
<SCRIPT LANGUAGE=\"JavaScript\">
<!--
	alert(\"$msg\");
	history.go(-$page);
//-->
</SCRIPT>
</BODY>
</HTML>
";
		exit;
	}
	function goback ($page, $meta) {
		print "
<HTML>
<HEAD>
<TITLE></TITLE>
$meta
<META HTTP-EQUIV=\"Pragma\" CONTENT=\"no-cache\">
<META HTTP-EQUIV=\"Expires\" CONTENT=\"0\">
</HEAD>
<BODY>
<SCRIPT LANGUAGE=\"JavaScript\">
<!--
	history.go(-$page);
//-->
</SCRIPT>
</BODY>
</HTML>
";
		exit;
	}
	function confirm ($msg, $ok, $cancel, $meta) {
		print "
<HTML>
<HEAD>
<TITLE></TITLE>
$meta
<META HTTP-EQUIV=\"Pragma\" CONTENT=\"no-cache\">
<META HTTP-EQUIV=\"Expires\" CONTENT=\"0\">
</HEAD>
<BODY>
<SCRIPT LANGUAGE=\"JavaScript\">
<!--
	if (confirm(\"$msg\")) {
		go = \"$ok\";
	}
	else {
		go = \"$cancel\";
	}
	window.open(go, '_self');
//-->
</SCRIPT>
</BODY>
</HTML>
";
		exit;
	}

} //-- Class End

// ###########################################################################

?>
